Index: palm/trunk/SOURCE/temperton_fft_mod.f90
===================================================================
--- palm/trunk/SOURCE/temperton_fft_mod.f90	(revision 3724)
+++ palm/trunk/SOURCE/temperton_fft_mod.f90	(revision 3725)
@@ -1325,758 +1365,770 @@
     REAL(wp) ::  b21(nfft) !< 
 
-    !  Intrinsic functions 
-!    INTRINSIC SQRT
-
-    !  Data statements 
-    DATA sin36/0.587785252292473_wp/, sin72/0.951056516295154_wp/, &
-         &      qrt5/0.559016994374947_wp/, sin60/0.866025403784437_wp/
-
-
-    !  Executable statements 
-
-    m = n/ifac
-    iink = la*inc1
-    jink = la*inc2
-    jump = (ifac-1)*jink
-    kstop = (n-ifac)/(2*ifac)
-
-    ibad = 1
-    IF (lot>nfft) GO TO 180
+
+    DATA  sin36/0.587785252292473_wp/, sin72/0.951056516295154_wp/,                                &
+          qrt5/0.559016994374947_wp/,  sin60/0.866025403784437_wp/
+
+
+    ierr = 0
+
+    m = n / ifac
+    iink = la * inc1
+    jink = la * inc2
+    jump = (ifac-1) * jink
+    kstop = (n-ifac) / (2*ifac)
+
+    IF ( lot > nfft )  THEN
+       ierr = 1
+       RETURN
+    ENDIF
     ibase = 0
     jbase = 0
     igo = ifac - 1
-    IF (igo==7) igo = 6
-    ibad = 2
-    IF (igo<1 .OR. igo>6) GO TO 180
-    GO TO (10,40,70,100,130,160) igo
-
-    ! Coding for factor 2
-
-10  CONTINUE
-    ia = 1
-    ib = ia + (2*m-la)*inc1
-    ja = 1
-    jb = ja + jink
-
-    IF (la==m) GO TO 30
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i) + a(ib+i)
-          c(jb+j) = a(ia+i) - a(ib+i)
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ia = ia + iink
-    iink = 2*iink
-    ib = ib - iink
-    ibase = 0
-    jbase = jbase + jump
-    jump = 2*jump + jink
-    IF (ia==ib) GO TO 20
-    DO k = la, kstop, la
-       kb = k + k
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       ibase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-             c(ja+j) = a(ia+i) + a(ib+i)
-             d(ja+j) = b(ia+i) - b(ib+i)
-             c(jb+j) = c1*(a(ia+i)-a(ib+i)) - s1*(b(ia+i)+b(ib+i))
-             d(jb+j) = s1*(a(ia+i)-a(ib+i)) + c1*(b(ia+i)+b(ib+i))
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ia = ia + iink
-       ib = ib - iink
-       jbase = jbase + jump
-    END DO
-    IF (ia>ib) GO TO 170
-20  CONTINUE
-    ibase = 0
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i)
-          c(jb+j) = -b(ia+i)
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-30  CONTINUE
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = 2.0_wp*(a(ia+i)+a(ib+i))
-          c(jb+j) = 2.0_wp*(a(ia+i)-a(ib+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    GO TO 170
-
-    ! Coding for factor 3
-
-40  CONTINUE
-    ia = 1
-    ib = ia + (2*m-la)*inc1
-    ic = ib
-    ja = 1
-    jb = ja + jink
-    jc = jb + jink
-
-    IF (la==m) GO TO 60
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i) + a(ib+i)
-          c(jb+j) = (a(ia+i)-0.5_wp*a(ib+i)) - (sin60*(b(ib+i)))
-          c(jc+j) = (a(ia+i)-0.5_wp*a(ib+i)) + (sin60*(b(ib+i)))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ia = ia + iink
-    iink = 2*iink
-    ib = ib + iink
-    ic = ic - iink
-    jbase = jbase + jump
-    jump = 2*jump + jink
-    IF (ia==ic) GO TO 50
-    DO k = la, kstop, la
-       kb = k + k
-       kc = kb + kb
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       c2 = trigs(kc+1)
-       s2 = trigs(kc+2)
-       ibase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-             c(ja+j) = a(ia+i) + (a(ib+i)+a(ic+i))
-             d(ja+j) = b(ia+i) + (b(ib+i)-b(ic+i))
-             c(jb+j) = c1*((a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)+ &
-                  &            b(ic+i))))                                      &
-                  &    - s1*((b(ia+i)-0.5_wp*(b(ib+i)-b(ic+i)))+(sin60*(a(ib+i)- &
-                  &            a(ic+i))))
-             d(jb+j) = s1*((a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)+ &
-                  &            b(ic+i))))                                      &
-                  &    + c1*((b(ia+i)-0.5_wp*(b(ib+i)-b(ic+i)))+(sin60*(a(ib+i)- &
-                  &            a(ic+i))))
-             c(jc+j) = c2*((a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)+ &
-                  &            b(ic+i))))                                      &
-                  &    - s2*((b(ia+i)-0.5_wp*(b(ib+i)-b(ic+i)))-(sin60*(a(ib+i)- &
-                  &            a(ic+i))))
-             d(jc+j) = s2*((a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)+ &
-                  &            b(ic+i))))                                      &
-                  &    + c2*((b(ia+i)-0.5_wp*(b(ib+i)-b(ic+i)))-(sin60*(a(ib+i)- &
-                  &            a(ic+i))))
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ia = ia + iink
-       ib = ib + iink
-       ic = ic - iink
-       jbase = jbase + jump
-    END DO
-    IF (ia>ic) GO TO 170
-50  CONTINUE
-    ibase = 0
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i) + a(ib+i)
-          c(jb+j) = (0.5_wp*a(ia+i)-a(ib+i)) - (sin60*b(ia+i))
-          c(jc+j) = -(0.5_wp*a(ia+i)-a(ib+i)) - (sin60*b(ia+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-60  CONTINUE
-    ssin60 = 2.0_wp*sin60
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = 2.0_wp*(a(ia+i)+a(ib+i))
-          c(jb+j) = (2.0_wp*a(ia+i)-a(ib+i)) - (ssin60*b(ib+i))
-          c(jc+j) = (2.0_wp*a(ia+i)-a(ib+i)) + (ssin60*b(ib+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    GO TO 170
-
-    ! Coding for factor 4
-
-70  CONTINUE
-    ia = 1
-    ib = ia + (2*m-la)*inc1
-    ic = ib + 2*m*inc1
-    id = ib
-    ja = 1
-    jb = ja + jink
-    jc = jb + jink
-    jd = jc + jink
-
-    IF (la==m) GO TO 90
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = (a(ia+i)+a(ic+i)) + a(ib+i)
-          c(jb+j) = (a(ia+i)-a(ic+i)) - b(ib+i)
-          c(jc+j) = (a(ia+i)+a(ic+i)) - a(ib+i)
-          c(jd+j) = (a(ia+i)-a(ic+i)) + b(ib+i)
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ia = ia + iink
-    iink = 2*iink
-    ib = ib + iink
-    ic = ic - iink
-    id = id - iink
-    jbase = jbase + jump
-    jump = 2*jump + jink
-    IF (ib==ic) GO TO 80
-    DO k = la, kstop, la
-       kb = k + k
-       kc = kb + kb
-       kd = kc + kb
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       c2 = trigs(kc+1)
-       s2 = trigs(kc+2)
-       c3 = trigs(kd+1)
-       s3 = trigs(kd+2)
-       ibase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-             c(ja+j) = (a(ia+i)+a(ic+i)) + (a(ib+i)+a(id+i))
-             d(ja+j) = (b(ia+i)-b(ic+i)) + (b(ib+i)-b(id+i))
-             c(jc+j) = c2*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i))) - s2*((b(ia+ &
-                  &            i)-b(ic+i))-(b(ib+i)-b(id+i)))
-             d(jc+j) = s2*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i))) + c2*((b(ia+ &
-                  &            i)-b(ic+i))-(b(ib+i)-b(id+i)))
-             c(jb+j) = c1*((a(ia+i)-a(ic+i))-(b(ib+i)+b(id+i))) - s1*((b(ia+ &
-                  &            i)+b(ic+i))+(a(ib+i)-a(id+i)))
-             d(jb+j) = s1*((a(ia+i)-a(ic+i))-(b(ib+i)+b(id+i))) + c1*((b(ia+ &
-                  &            i)+b(ic+i))+(a(ib+i)-a(id+i)))
-             c(jd+j) = c3*((a(ia+i)-a(ic+i))+(b(ib+i)+b(id+i))) - s3*((b(ia+ &
-                  &            i)+b(ic+i))-(a(ib+i)-a(id+i)))
-             d(jd+j) = s3*((a(ia+i)-a(ic+i))+(b(ib+i)+b(id+i))) + c3*((b(ia+ &
-                  &            i)+b(ic+i))-(a(ib+i)-a(id+i)))
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ia = ia + iink
-       ib = ib + iink
-       ic = ic - iink
-       id = id - iink
-       jbase = jbase + jump
-    END DO
-    IF (ib>ic) GO TO 170
-80  CONTINUE
-    ibase = 0
-    sin45 = SQRT(0.5_wp)
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i) + a(ib+i)
-          c(jb+j) = sin45*((a(ia+i)-a(ib+i))-(b(ia+i)+b(ib+i)))
-          c(jc+j) = b(ib+i) - b(ia+i)
-          c(jd+j) = -sin45*((a(ia+i)-a(ib+i))+(b(ia+i)+b(ib+i)))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-90  CONTINUE
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = 2.0_wp*((a(ia+i)+a(ic+i))+a(ib+i))
-          c(jb+j) = 2.0_wp*((a(ia+i)-a(ic+i))-b(ib+i))
-          c(jc+j) = 2.0_wp*((a(ia+i)+a(ic+i))-a(ib+i))
-          c(jd+j) = 2.0_wp*((a(ia+i)-a(ic+i))+b(ib+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    ! Coding for factor 5
-
-    GO TO 170
-100 CONTINUE
-    ia = 1
-    ib = ia + (2*m-la)*inc1
-    ic = ib + 2*m*inc1
-    id = ic
-    ie = ib
-    ja = 1
-    jb = ja + jink
-    jc = jb + jink
-    jd = jc + jink
-    je = jd + jink
-
-    IF (la==m) GO TO 120
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i) + (a(ib+i)+a(ic+i))
-          c(jb+j) = ((a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))+qrt5*(a(ib+i)-a(ic+i))) - &
-               &          (sin72*b(ib+i)+sin36*b(ic+i))
-          c(jc+j) = ((a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))-qrt5*(a(ib+i)-a(ic+i))) - &
-               &          (sin36*b(ib+i)-sin72*b(ic+i))
-          c(jd+j) = ((a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))-qrt5*(a(ib+i)-a(ic+i))) + &
-               &          (sin36*b(ib+i)-sin72*b(ic+i))
-          c(je+j) = ((a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))+qrt5*(a(ib+i)-a(ic+i))) + &
-               &          (sin72*b(ib+i)+sin36*b(ic+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ia = ia + iink
-    iink = 2*iink
-    ib = ib + iink
-    ic = ic + iink
-    id = id - iink
-    ie = ie - iink
-    jbase = jbase + jump
-    jump = 2*jump + jink
-    IF (ib==id) GO TO 110
-    DO k = la, kstop, la
-       kb = k + k
-       kc = kb + kb
-       kd = kc + kb
-       ke = kd + kb
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       c2 = trigs(kc+1)
-       s2 = trigs(kc+2)
-       c3 = trigs(kd+1)
-       s3 = trigs(kd+2)
-       c4 = trigs(ke+1)
-       s4 = trigs(ke+2)
-       ibase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-
-             a10(ijk) = (a(ia+i)-0.25_wp*((a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i)))) + &
-                  &            qrt5*((a(ib+i)+a(ie+i))-(a(ic+i)+a(id+i)))
-             a20(ijk) = (a(ia+i)-0.25_wp*((a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i)))) - &
-                  &            qrt5*((a(ib+i)+a(ie+i))-(a(ic+i)+a(id+i)))
-             b10(ijk) = (b(ia+i)-0.25_wp*((b(ib+i)-b(ie+i))+(b(ic+i)-b(id+i)))) + &
-                  &            qrt5*((b(ib+i)-b(ie+i))-(b(ic+i)-b(id+i)))
-             b20(ijk) = (b(ia+i)-0.25_wp*((b(ib+i)-b(ie+i))+(b(ic+i)-b(id+i)))) - &
-                  &            qrt5*((b(ib+i)-b(ie+i))-(b(ic+i)-b(id+i)))
-             a11(ijk) = sin72*(b(ib+i)+b(ie+i)) + sin36*(b(ic+i)+b(id+i))
-             a21(ijk) = sin36*(b(ib+i)+b(ie+i)) - sin72*(b(ic+i)+b(id+i))
-             b11(ijk) = sin72*(a(ib+i)-a(ie+i)) + sin36*(a(ic+i)-a(id+i))
-             b21(ijk) = sin36*(a(ib+i)-a(ie+i)) - sin72*(a(ic+i)-a(id+i))
-
-             c(ja+j) = a(ia+i) + ((a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i)))
-             d(ja+j) = b(ia+i) + ((b(ib+i)-b(ie+i))+(b(ic+i)-b(id+i)))
-             c(jb+j) = c1*(a10(ijk)-a11(ijk)) - s1*(b10(ijk)+b11(ijk))
-             d(jb+j) = s1*(a10(ijk)-a11(ijk)) + c1*(b10(ijk)+b11(ijk))
-             c(je+j) = c4*(a10(ijk)+a11(ijk)) - s4*(b10(ijk)-b11(ijk))
-             d(je+j) = s4*(a10(ijk)+a11(ijk)) + c4*(b10(ijk)-b11(ijk))
-             c(jc+j) = c2*(a20(ijk)-a21(ijk)) - s2*(b20(ijk)+b21(ijk))
-             d(jc+j) = s2*(a20(ijk)-a21(ijk)) + c2*(b20(ijk)+b21(ijk))
-             c(jd+j) = c3*(a20(ijk)+a21(ijk)) - s3*(b20(ijk)-b21(ijk))
-             d(jd+j) = s3*(a20(ijk)+a21(ijk)) + c3*(b20(ijk)-b21(ijk))
-
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ia = ia + iink
-       ib = ib + iink
-       ic = ic + iink
-       id = id - iink
-       ie = ie - iink
-       jbase = jbase + jump
-    END DO
-    IF (ib>id) GO TO 170
-110 CONTINUE
-    ibase = 0
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = (a(ia+i)+a(ib+i)) + a(ic+i)
-          c(jb+j) = (qrt5*(a(ia+i)-a(ib+i))+(0.25_wp*(a(ia+i)+a(ib+i))-a(ic+i))) - &
-               &          (sin36*b(ia+i)+sin72*b(ib+i))
-          c(je+j) = -(qrt5*(a(ia+i)-a(ib+i))+(0.25_wp*(a(ia+i)+a(ib+i))-a(ic+i))) - &
-               &          (sin36*b(ia+i)+sin72*b(ib+i))
-          c(jc+j) = (qrt5*(a(ia+i)-a(ib+i))-(0.25_wp*(a(ia+i)+a(ib+i))-a(ic+i))) - &
-               &          (sin72*b(ia+i)-sin36*b(ib+i))
-          c(jd+j) = -(qrt5*(a(ia+i)-a(ib+i))-(0.25_wp*(a(ia+i)+a(ib+i))-a(ic+i))) - &
-               &          (sin72*b(ia+i)-sin36*b(ib+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-120 CONTINUE
-    qqrt5 = 2.0_wp*qrt5
-    ssin36 = 2.0_wp*sin36
-    ssin72 = 2.0_wp*sin72
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = 2.0_wp*(a(ia+i)+(a(ib+i)+a(ic+i)))
-          c(jb+j) = (2.0_wp*(a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))+qqrt5*(a(ib+i)-a(ic+ &
-               &          i))) - (ssin72*b(ib+i)+ssin36*b(ic+i))
-          c(jc+j) = (2.0_wp*(a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))-qqrt5*(a(ib+i)-a(ic+ &
-               &          i))) - (ssin36*b(ib+i)-ssin72*b(ic+i))
-          c(jd+j) = (2.0_wp*(a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))-qqrt5*(a(ib+i)-a(ic+ &
-               &          i))) + (ssin36*b(ib+i)-ssin72*b(ic+i))
-          c(je+j) = (2.0_wp*(a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))+qqrt5*(a(ib+i)-a(ic+ &
-               &          i))) + (ssin72*b(ib+i)+ssin36*b(ic+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    GO TO 170
-
-    ! Coding for factor 6
-
-130 CONTINUE
-    ia = 1
-    ib = ia + (2*m-la)*inc1
-    ic = ib + 2*m*inc1
-    id = ic + 2*m*inc1
-    ie = ic
-    if = ib
-    ja = 1
-    jb = ja + jink
-    jc = jb + jink
-    jd = jc + jink
-    je = jd + jink
-    jf = je + jink
-
-    IF (la==m) GO TO 150
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = (a(ia+i)+a(id+i)) + (a(ib+i)+a(ic+i))
-          c(jd+j) = (a(ia+i)-a(id+i)) - (a(ib+i)-a(ic+i))
-          c(jb+j) = ((a(ia+i)-a(id+i))+0.5_wp*(a(ib+i)-a(ic+i))) - (sin60*(b(ib+ &
-               &          i)+b(ic+i)))
-          c(jf+j) = ((a(ia+i)-a(id+i))+0.5_wp*(a(ib+i)-a(ic+i))) + (sin60*(b(ib+ &
-               &          i)+b(ic+i)))
-          c(jc+j) = ((a(ia+i)+a(id+i))-0.5_wp*(a(ib+i)+a(ic+i))) - (sin60*(b(ib+ &
-               &          i)-b(ic+i)))
-          c(je+j) = ((a(ia+i)+a(id+i))-0.5_wp*(a(ib+i)+a(ic+i))) + (sin60*(b(ib+ &
-               &          i)-b(ic+i)))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ia = ia + iink
-    iink = 2*iink
-    ib = ib + iink
-    ic = ic + iink
-    id = id - iink
-    ie = ie - iink
-    if = if - iink
-    jbase = jbase + jump
-    jump = 2*jump + jink
-    IF (ic==id) GO TO 140
-    DO k = la, kstop, la
-       kb = k + k
-       kc = kb + kb
-       kd = kc + kb
-       ke = kd + kb
-       kf = ke + kb
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       c2 = trigs(kc+1)
-       s2 = trigs(kc+2)
-       c3 = trigs(kd+1)
-       s3 = trigs(kd+2)
-       c4 = trigs(ke+1)
-       s4 = trigs(ke+2)
-       c5 = trigs(kf+1)
-       s5 = trigs(kf+2)
-       ibase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-
-             a11(ijk) = (a(ie+i)+a(ib+i)) + (a(ic+i)+a(if+i))
-             a20(ijk) = (a(ia+i)+a(id+i)) - 0.5_wp*a11(ijk)
-             a21(ijk) = sin60*((a(ie+i)+a(ib+i))-(a(ic+i)+a(if+i)))
-             b11(ijk) = (b(ib+i)-b(ie+i)) + (b(ic+i)-b(if+i))
-             b20(ijk) = (b(ia+i)-b(id+i)) - 0.5_wp*b11(ijk)
-             b21(ijk) = sin60*((b(ib+i)-b(ie+i))-(b(ic+i)-b(if+i)))
-
-             c(ja+j) = (a(ia+i)+a(id+i)) + a11(ijk)
-             d(ja+j) = (b(ia+i)-b(id+i)) + b11(ijk)
-             c(jc+j) = c2*(a20(ijk)-b21(ijk)) - s2*(b20(ijk)+a21(ijk))
-             d(jc+j) = s2*(a20(ijk)-b21(ijk)) + c2*(b20(ijk)+a21(ijk))
-             c(je+j) = c4*(a20(ijk)+b21(ijk)) - s4*(b20(ijk)-a21(ijk))
-             d(je+j) = s4*(a20(ijk)+b21(ijk)) + c4*(b20(ijk)-a21(ijk))
-
-             a11(ijk) = (a(ie+i)-a(ib+i)) + (a(ic+i)-a(if+i))
-             b11(ijk) = (b(ie+i)+b(ib+i)) - (b(ic+i)+b(if+i))
-             a20(ijk) = (a(ia+i)-a(id+i)) - 0.5_wp*a11(ijk)
-             a21(ijk) = sin60*((a(ie+i)-a(ib+i))-(a(ic+i)-a(if+i)))
-             b20(ijk) = (b(ia+i)+b(id+i)) + 0.5_wp*b11(ijk)
-             b21(ijk) = sin60*((b(ie+i)+b(ib+i))+(b(ic+i)+b(if+i)))
-
-             c(jd+j) = c3*((a(ia+i)-a(id+i))+a11(ijk)) - s3*((b(ia+i)+b(id+ &
-                  &            i))-b11(ijk))
-             d(jd+j) = s3*((a(ia+i)-a(id+i))+a11(ijk)) + c3*((b(ia+i)+b(id+ &
-                  &            i))-b11(ijk))
-             c(jb+j) = c1*(a20(ijk)-b21(ijk)) - s1*(b20(ijk)-a21(ijk))
-             d(jb+j) = s1*(a20(ijk)-b21(ijk)) + c1*(b20(ijk)-a21(ijk))
-             c(jf+j) = c5*(a20(ijk)+b21(ijk)) - s5*(b20(ijk)+a21(ijk))
-             d(jf+j) = s5*(a20(ijk)+b21(ijk)) + c5*(b20(ijk)+a21(ijk))
-
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ia = ia + iink
-       ib = ib + iink
-       ic = ic + iink
-       id = id - iink
-       ie = ie - iink
-       if = if - iink
-       jbase = jbase + jump
-    END DO
-    IF (ic>id) GO TO 170
-140 CONTINUE
-    ibase = 0
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ib+i) + (a(ia+i)+a(ic+i))
-          c(jd+j) = b(ib+i) - (b(ia+i)+b(ic+i))
-          c(jb+j) = (sin60*(a(ia+i)-a(ic+i))) - (0.5_wp*(b(ia+i)+b(ic+i))+b(ib+i))
-          c(jf+j) = -(sin60*(a(ia+i)-a(ic+i))) - (0.5_wp*(b(ia+i)+b(ic+i))+b(ib+i))
-          c(jc+j) = sin60*(b(ic+i)-b(ia+i)) + (0.5_wp*(a(ia+i)+a(ic+i))-a(ib+i))
-          c(je+j) = sin60*(b(ic+i)-b(ia+i)) - (0.5_wp*(a(ia+i)+a(ic+i))-a(ib+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-150 CONTINUE
-    ssin60 = 2.0_wp*sin60
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = (2.0_wp*(a(ia+i)+a(id+i))) + (2.0_wp*(a(ib+i)+a(ic+i)))
-          c(jd+j) = (2.0_wp*(a(ia+i)-a(id+i))) - (2.0_wp*(a(ib+i)-a(ic+i)))
-          c(jb+j) = (2.0_wp*(a(ia+i)-a(id+i))+(a(ib+i)-a(ic+i))) - (ssin60*(b(ib+ &
-               &          i)+b(ic+i)))
-          c(jf+j) = (2.0_wp*(a(ia+i)-a(id+i))+(a(ib+i)-a(ic+i))) + (ssin60*(b(ib+ &
-               &          i)+b(ic+i)))
-          c(jc+j) = (2.0_wp*(a(ia+i)+a(id+i))-(a(ib+i)+a(ic+i))) - (ssin60*(b(ib+ &
-               &          i)-b(ic+i)))
-          c(je+j) = (2.0_wp*(a(ia+i)+a(id+i))-(a(ib+i)+a(ic+i))) + (ssin60*(b(ib+ &
-               &          i)-b(ic+i)))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    GO TO 170
-
-    ! Coding for factor 8
-
-160 CONTINUE
-    ibad = 3
-    IF (la/=m) GO TO 180
-    ia = 1
-    ib = ia + la*inc1
-    ic = ib + 2*la*inc1
-    id = ic + 2*la*inc1
-    ie = id + 2*la*inc1
-    ja = 1
-    jb = ja + jink
-    jc = jb + jink
-    jd = jc + jink
-    je = jd + jink
-    jf = je + jink
-    jg = jf + jink
-    jh = jg + jink
-    ssin45 = SQRT(2.0_wp)
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = 2.0_wp*(((a(ia+i)+a(ie+i))+a(ic+i))+(a(ib+i)+a(id+i)))
-          c(je+j) = 2.0_wp*(((a(ia+i)+a(ie+i))+a(ic+i))-(a(ib+i)+a(id+i)))
-          c(jc+j) = 2.0_wp*(((a(ia+i)+a(ie+i))-a(ic+i))-(b(ib+i)-b(id+i)))
-          c(jg+j) = 2.0_wp*(((a(ia+i)+a(ie+i))-a(ic+i))+(b(ib+i)-b(id+i)))
-          c(jb+j) = 2.0_wp*((a(ia+i)-a(ie+i))-b(ic+i)) + ssin45*((a(ib+i)-a(id+ &
-               &              i))-(b(ib+i)+b(id+i)))
-          c(jf+j) = 2.0_wp*((a(ia+i)-a(ie+i))-b(ic+i)) - ssin45*((a(ib+i)-a(id+ &
-               &              i))-(b(ib+i)+b(id+i)))
-          c(jd+j) = 2.0_wp*((a(ia+i)-a(ie+i))+b(ic+i)) - ssin45*((a(ib+i)-a(id+ &
-               &              i))+(b(ib+i)+b(id+i)))
-          c(jh+j) = 2.0_wp*((a(ia+i)-a(ie+i))+b(ic+i)) + ssin45*((a(ib+i)-a(id+ &
-               &              i))+(b(ib+i)+b(id+i)))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    ! Return
-
-170 CONTINUE
-    ibad = 0
-180 CONTINUE
-    ierr = ibad
-    RETURN
-  END SUBROUTINE rpassm
+    IF ( igo == 7 )  igo = 6
+    IF ( igo < 1  .OR.  igo > 6 )  THEN
+       ierr = 2
+       RETURN
+    ENDIF
+
+
+    SELECT CASE ( igo )
+!
+!--    Coding for factor 2
+       CASE ( 1 )
+
+          ia = 1
+          ib = ia + (2*m-la) * inc1
+          ja = 1
+          jb = ja + jink
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i) + a(ib+i)
+                   c(jb+j) = a(ia+i) - a(ib+i)
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+             ia = ia + iink
+             iink = 2 * iink
+             ib = ib - iink
+             ibase = 0
+             jbase = jbase + jump
+             jump = 2 * jump + jink
+
+             IF ( ia /= ib )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   ibase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         c(ja+j) = a(ia+i) + a(ib+i)
+                         d(ja+j) = b(ia+i) - b(ib+i)
+                         c(jb+j) = c1*(a(ia+i)-a(ib+i)) - s1*(b(ia+i)+b(ib+i))
+                         d(jb+j) = s1*(a(ia+i)-a(ib+i)) + c1*(b(ia+i)+b(ib+i))
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+                   ia = ia + iink
+                   ib = ib - iink
+                   jbase = jbase + jump
+                ENDDO
+
+                IF ( ia > ib )  RETURN
+
+             ENDIF
+
+             ibase = 0
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i)
+                   c(jb+j) = -b(ia+i)
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = 2.0_wp*(a(ia+i)+a(ib+i))
+                   c(jb+j) = 2.0_wp*(a(ia+i)-a(ib+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 3
+       CASE ( 2 )
+
+          ia = 1
+          ib = ia + (2*m-la) * inc1
+          ic = ib
+          ja = 1
+          jb = ja + jink
+          jc = jb + jink
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i) + a(ib+i)
+                   c(jb+j) = (a(ia+i)-0.5_wp*a(ib+i)) - (sin60*(b(ib+i)))
+                   c(jc+j) = (a(ia+i)-0.5_wp*a(ib+i)) + (sin60*(b(ib+i)))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+             ia = ia + iink
+             iink = 2 * iink
+             ib = ib + iink
+             ic = ic - iink
+             jbase = jbase + jump
+             jump = 2 * jump + jink
+
+             IF ( ia /= ic )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   kc = kb + kb
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   c2 = trigs(kc+1)
+                   s2 = trigs(kc+2)
+                   ibase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         c(ja+j) = a(ia+i) + (a(ib+i)+a(ic+i))
+                         d(ja+j) = b(ia+i) + (b(ib+i)-b(ic+i))
+                         c(jb+j) = c1*((a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)+ b(ic+i)))) &
+                                   - s1*((b(ia+i)-0.5_wp*(b(ib+i)-b(ic+i)))+(sin60*(a(ib+i)- a(ic+i))))
+                         d(jb+j) = s1*((a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)+ b(ic+i)))) &
+                                   + c1*((b(ia+i)-0.5_wp*(b(ib+i)-b(ic+i)))+(sin60*(a(ib+i)- a(ic+i))))
+                         c(jc+j) = c2*((a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)+ b(ic+i)))) &
+                                   - s2*((b(ia+i)-0.5_wp*(b(ib+i)-b(ic+i)))-(sin60*(a(ib+i)- a(ic+i))))
+                         d(jc+j) = s2*((a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)+ b(ic+i)))) &
+                                   + c2*((b(ia+i)-0.5_wp*(b(ib+i)-b(ic+i)))-(sin60*(a(ib+i)- a(ic+i))))
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+                   ia = ia + iink
+                   ib = ib + iink
+                   ic = ic - iink
+                   jbase = jbase + jump
+                ENDDO
+
+                IF ( ia > ic )  RETURN
+
+             ENDIF
+
+             ibase = 0
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i) + a(ib+i)
+                   c(jb+j) = (0.5_wp*a(ia+i)-a(ib+i)) - (sin60*b(ia+i))
+                   c(jc+j) = -(0.5_wp*a(ia+i)-a(ib+i)) - (sin60*b(ia+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             ssin60 = 2.0_wp * sin60
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = 2.0_wp*(a(ia+i)+a(ib+i))
+                   c(jb+j) = (2.0_wp*a(ia+i)-a(ib+i)) - (ssin60*b(ib+i))
+                   c(jc+j) = (2.0_wp*a(ia+i)-a(ib+i)) + (ssin60*b(ib+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 4
+       CASE ( 3 )
+
+          ia = 1
+          ib = ia + (2*m-la) * inc1
+          ic = ib + 2*m*inc1
+          id = ib
+          ja = 1
+          jb = ja + jink
+          jc = jb + jink
+          jd = jc + jink
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = (a(ia+i)+a(ic+i)) + a(ib+i)
+                   c(jb+j) = (a(ia+i)-a(ic+i)) - b(ib+i)
+                   c(jc+j) = (a(ia+i)+a(ic+i)) - a(ib+i)
+                   c(jd+j) = (a(ia+i)-a(ic+i)) + b(ib+i)
+                   i = i + inc3
+                   j = j + inc4
+               ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+             ia = ia + iink
+             iink = 2 * iink
+             ib = ib + iink
+             ic = ic - iink
+             id = id - iink
+             jbase = jbase + jump
+             jump = 2 * jump + jink
+
+             IF ( ib /= ic )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   kc = kb + kb
+                   kd = kc + kb
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   c2 = trigs(kc+1)
+                   s2 = trigs(kc+2)
+                   c3 = trigs(kd+1)
+                   s3 = trigs(kd+2)
+                   ibase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         c(ja+j) = (a(ia+i)+a(ic+i)) + (a(ib+i)+a(id+i))
+                         d(ja+j) = (b(ia+i)-b(ic+i)) + (b(ib+i)-b(id+i))
+                         c(jc+j) = c2*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i))) - s2*((b(ia+i)-b(ic+i))&
+                                   -(b(ib+i)-b(id+i)))
+                         d(jc+j) = s2*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i))) + c2*((b(ia+i)-b(ic+i))&
+                                   -(b(ib+i)-b(id+i)))
+                         c(jb+j) = c1*((a(ia+i)-a(ic+i))-(b(ib+i)+b(id+i))) - s1*((b(ia+i)+b(ic+i))&
+                                   +(a(ib+i)-a(id+i)))
+                         d(jb+j) = s1*((a(ia+i)-a(ic+i))-(b(ib+i)+b(id+i))) + c1*((b(ia+i)+b(ic+i))&
+                                   +(a(ib+i)-a(id+i)))
+                         c(jd+j) = c3*((a(ia+i)-a(ic+i))+(b(ib+i)+b(id+i))) - s3*((b(ia+i)+b(ic+i))&
+                                   -(a(ib+i)-a(id+i)))
+                         d(jd+j) = s3*((a(ia+i)-a(ic+i))+(b(ib+i)+b(id+i))) + c3*((b(ia+i)+b(ic+i))&
+                                   -(a(ib+i)-a(id+i)))
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+                   ia = ia + iink
+                   ib = ib + iink
+                   ic = ic - iink
+                   id = id - iink
+                   jbase = jbase + jump
+                ENDDO
+
+                IF ( ib > ic )  RETURN
+
+             ENDIF
+
+             ibase = 0
+             sin45 = SQRT( 0.5_wp )
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i) + a(ib+i)
+                   c(jb+j) = sin45*((a(ia+i)-a(ib+i))-(b(ia+i)+b(ib+i)))
+                   c(jc+j) = b(ib+i) - b(ia+i)
+                   c(jd+j) = -sin45*((a(ia+i)-a(ib+i))+(b(ia+i)+b(ib+i)))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = 2.0_wp*((a(ia+i)+a(ic+i))+a(ib+i))
+                   c(jb+j) = 2.0_wp*((a(ia+i)-a(ic+i))-b(ib+i))
+                   c(jc+j) = 2.0_wp*((a(ia+i)+a(ic+i))-a(ib+i))
+                   c(jd+j) = 2.0_wp*((a(ia+i)-a(ic+i))+b(ib+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 5
+       CASE ( 4 )
+
+          ia = 1
+          ib = ia + (2*m-la) * inc1
+          ic = ib + 2*m*inc1
+          id = ic
+          ie = ib
+          ja = 1
+          jb = ja + jink
+          jc = jb + jink
+          jd = jc + jink
+          je = jd + jink
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i) + (a(ib+i)+a(ic+i))
+                   c(jb+j) = ((a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))+qrt5*(a(ib+i)-a(ic+i))) -        &
+                             (sin72*b(ib+i)+sin36*b(ic+i))
+                   c(jc+j) = ((a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))-qrt5*(a(ib+i)-a(ic+i))) -        &
+                             (sin36*b(ib+i)-sin72*b(ic+i))
+                   c(jd+j) = ((a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))-qrt5*(a(ib+i)-a(ic+i))) +        &
+                             (sin36*b(ib+i)-sin72*b(ic+i))
+                   c(je+j) = ((a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))+qrt5*(a(ib+i)-a(ic+i))) +        &
+                             (sin72*b(ib+i)+sin36*b(ic+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+             ia = ia + iink
+             iink = 2 * iink
+             ib = ib + iink
+             ic = ic + iink
+             id = id - iink
+             ie = ie - iink
+             jbase = jbase + jump
+             jump = 2 * jump + jink
+
+             IF ( ib /= id )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   kc = kb + kb
+                   kd = kc + kb
+                   ke = kd + kb
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   c2 = trigs(kc+1)
+                   s2 = trigs(kc+2)
+                   c3 = trigs(kd+1)
+                   s3 = trigs(kd+2)
+                   c4 = trigs(ke+1)
+                   s4 = trigs(ke+2)
+                   ibase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         a10(ijk) = (a(ia+i)-0.25_wp*((a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i)))) +      &
+                                    qrt5*((a(ib+i)+a(ie+i))-(a(ic+i)+a(id+i)))
+                         a20(ijk) = (a(ia+i)-0.25_wp*((a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i)))) -      &
+                                    qrt5*((a(ib+i)+a(ie+i))-(a(ic+i)+a(id+i)))
+                         b10(ijk) = (b(ia+i)-0.25_wp*((b(ib+i)-b(ie+i))+(b(ic+i)-b(id+i)))) +      &
+                                    qrt5*((b(ib+i)-b(ie+i))-(b(ic+i)-b(id+i)))
+                         b20(ijk) = (b(ia+i)-0.25_wp*((b(ib+i)-b(ie+i))+(b(ic+i)-b(id+i)))) -      &
+                                    qrt5*((b(ib+i)-b(ie+i))-(b(ic+i)-b(id+i)))
+                         a11(ijk) = sin72*(b(ib+i)+b(ie+i)) + sin36*(b(ic+i)+b(id+i))
+                         a21(ijk) = sin36*(b(ib+i)+b(ie+i)) - sin72*(b(ic+i)+b(id+i))
+                         b11(ijk) = sin72*(a(ib+i)-a(ie+i)) + sin36*(a(ic+i)-a(id+i))
+                         b21(ijk) = sin36*(a(ib+i)-a(ie+i)) - sin72*(a(ic+i)-a(id+i))
+                         c(ja+j) = a(ia+i) + ((a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i)))
+                         d(ja+j) = b(ia+i) + ((b(ib+i)-b(ie+i))+(b(ic+i)-b(id+i)))
+                         c(jb+j) = c1*(a10(ijk)-a11(ijk)) - s1*(b10(ijk)+b11(ijk))
+                         d(jb+j) = s1*(a10(ijk)-a11(ijk)) + c1*(b10(ijk)+b11(ijk))
+                         c(je+j) = c4*(a10(ijk)+a11(ijk)) - s4*(b10(ijk)-b11(ijk))
+                         d(je+j) = s4*(a10(ijk)+a11(ijk)) + c4*(b10(ijk)-b11(ijk))
+                         c(jc+j) = c2*(a20(ijk)-a21(ijk)) - s2*(b20(ijk)+b21(ijk))
+                         d(jc+j) = s2*(a20(ijk)-a21(ijk)) + c2*(b20(ijk)+b21(ijk))
+                         c(jd+j) = c3*(a20(ijk)+a21(ijk)) - s3*(b20(ijk)-b21(ijk))
+                         d(jd+j) = s3*(a20(ijk)+a21(ijk)) + c3*(b20(ijk)-b21(ijk))
+
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+                   ia = ia + iink
+                   ib = ib + iink
+                   ic = ic + iink
+                   id = id - iink
+                   ie = ie - iink
+                   jbase = jbase + jump
+                ENDDO
+
+                IF ( ib > id )  RETURN
+
+             ENDIF
+
+             ibase = 0
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = (a(ia+i)+a(ib+i)) + a(ic+i)
+                   c(jb+j) = (qrt5*(a(ia+i)-a(ib+i))+(0.25_wp*(a(ia+i)+a(ib+i))-a(ic+i))) -        &
+                             (sin36*b(ia+i)+sin72*b(ib+i))
+                   c(je+j) = -(qrt5*(a(ia+i)-a(ib+i))+(0.25_wp*(a(ia+i)+a(ib+i))-a(ic+i))) -       &
+                             (sin36*b(ia+i)+sin72*b(ib+i))
+                   c(jc+j) = (qrt5*(a(ia+i)-a(ib+i))-(0.25_wp*(a(ia+i)+a(ib+i))-a(ic+i))) -        &
+                             (sin72*b(ia+i)-sin36*b(ib+i))
+                   c(jd+j) = -(qrt5*(a(ia+i)-a(ib+i))-(0.25_wp*(a(ia+i)+a(ib+i))-a(ic+i))) -       &
+                             (sin72*b(ia+i)-sin36*b(ib+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             qqrt5  = 2.0_wp * qrt5
+             ssin36 = 2.0_wp * sin36
+             ssin72 = 2.0_wp * sin72
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = 2.0_wp*(a(ia+i)+(a(ib+i)+a(ic+i)))
+                   c(jb+j) = (2.0_wp*(a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))+qqrt5*(a(ib+i)-a(ic+i)))  &
+                             - (ssin72*b(ib+i)+ssin36*b(ic+i))
+                   c(jc+j) = (2.0_wp*(a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))-qqrt5*(a(ib+i)-a(ic+i)))  &
+                             - (ssin36*b(ib+i)-ssin72*b(ic+i))
+                   c(jd+j) = (2.0_wp*(a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))-qqrt5*(a(ib+i)-a(ic+i)))  &
+                             + (ssin36*b(ib+i)-ssin72*b(ic+i))
+                   c(je+j) = (2.0_wp*(a(ia+i)-0.25_wp*(a(ib+i)+a(ic+i)))+qqrt5*(a(ib+i)-a(ic+i)))  &
+                             + (ssin72*b(ib+i)+ssin36*b(ic+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 6
+       CASE ( 5 )
+
+          ia = 1
+          ib = ia + (2*m-la) * inc1
+          ic = ib + 2*m*inc1
+          id = ic + 2*m*inc1
+          ie = ic
+          if = ib
+          ja = 1
+          jb = ja + jink
+          jc = jb + jink
+          jd = jc + jink
+          je = jd + jink
+          jf = je + jink
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = (a(ia+i)+a(id+i)) + (a(ib+i)+a(ic+i))
+                   c(jd+j) = (a(ia+i)-a(id+i)) - (a(ib+i)-a(ic+i))
+                   c(jb+j) = ((a(ia+i)-a(id+i))+0.5_wp*(a(ib+i)-a(ic+i))) - (sin60*(b(ib+i)+b(ic+i)))
+                   c(jf+j) = ((a(ia+i)-a(id+i))+0.5_wp*(a(ib+i)-a(ic+i))) + (sin60*(b(ib+i)+b(ic+i)))
+                   c(jc+j) = ((a(ia+i)+a(id+i))-0.5_wp*(a(ib+i)+a(ic+i))) - (sin60*(b(ib+i)-b(ic+i)))
+                   c(je+j) = ((a(ia+i)+a(id+i))-0.5_wp*(a(ib+i)+a(ic+i))) + (sin60*(b(ib+i)-b(ic+i)))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+             ia = ia + iink
+             iink = 2 * iink
+             ib = ib + iink
+             ic = ic + iink
+             id = id - iink
+             ie = ie - iink
+             if = if - iink
+             jbase = jbase + jump
+             jump = 2 * jump + jink
+
+             IF ( ic /= id )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   kc = kb + kb
+                   kd = kc + kb
+                   ke = kd + kb
+                   kf = ke + kb
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   c2 = trigs(kc+1)
+                   s2 = trigs(kc+2)
+                   c3 = trigs(kd+1)
+                   s3 = trigs(kd+2)
+                   c4 = trigs(ke+1)
+                   s4 = trigs(ke+2)
+                   c5 = trigs(kf+1)
+                   s5 = trigs(kf+2)
+                   ibase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         a11(ijk) = (a(ie+i)+a(ib+i)) + (a(ic+i)+a(if+i))
+                         a20(ijk) = (a(ia+i)+a(id+i)) - 0.5_wp*a11(ijk)
+                         a21(ijk) = sin60*((a(ie+i)+a(ib+i))-(a(ic+i)+a(if+i)))
+                         b11(ijk) = (b(ib+i)-b(ie+i)) + (b(ic+i)-b(if+i))
+                         b20(ijk) = (b(ia+i)-b(id+i)) - 0.5_wp*b11(ijk)
+                         b21(ijk) = sin60*((b(ib+i)-b(ie+i))-(b(ic+i)-b(if+i)))
+
+                         c(ja+j) = (a(ia+i)+a(id+i)) + a11(ijk)
+                         d(ja+j) = (b(ia+i)-b(id+i)) + b11(ijk)
+                         c(jc+j) = c2*(a20(ijk)-b21(ijk)) - s2*(b20(ijk)+a21(ijk))
+                         d(jc+j) = s2*(a20(ijk)-b21(ijk)) + c2*(b20(ijk)+a21(ijk))
+                         c(je+j) = c4*(a20(ijk)+b21(ijk)) - s4*(b20(ijk)-a21(ijk))
+                         d(je+j) = s4*(a20(ijk)+b21(ijk)) + c4*(b20(ijk)-a21(ijk))
+
+                         a11(ijk) = (a(ie+i)-a(ib+i)) + (a(ic+i)-a(if+i))
+                         b11(ijk) = (b(ie+i)+b(ib+i)) - (b(ic+i)+b(if+i))
+                         a20(ijk) = (a(ia+i)-a(id+i)) - 0.5_wp*a11(ijk)
+                         a21(ijk) = sin60*((a(ie+i)-a(ib+i))-(a(ic+i)-a(if+i)))
+                         b20(ijk) = (b(ia+i)+b(id+i)) + 0.5_wp*b11(ijk)
+                         b21(ijk) = sin60*((b(ie+i)+b(ib+i))+(b(ic+i)+b(if+i)))
+
+                         c(jd+j) = c3*((a(ia+i)-a(id+i))+a11(ijk)) - s3*((b(ia+i)+b(id+i))-b11(ijk))
+                         d(jd+j) = s3*((a(ia+i)-a(id+i))+a11(ijk)) + c3*((b(ia+i)+b(id+i))-b11(ijk))
+                         c(jb+j) = c1*(a20(ijk)-b21(ijk)) - s1*(b20(ijk)-a21(ijk))
+                         d(jb+j) = s1*(a20(ijk)-b21(ijk)) + c1*(b20(ijk)-a21(ijk))
+                         c(jf+j) = c5*(a20(ijk)+b21(ijk)) - s5*(b20(ijk)+a21(ijk))
+                         d(jf+j) = s5*(a20(ijk)+b21(ijk)) + c5*(b20(ijk)+a21(ijk))
+
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+                   ia = ia + iink
+                   ib = ib + iink
+                   ic = ic + iink
+                   id = id - iink
+                   ie = ie - iink
+                   if = if - iink
+                   jbase = jbase + jump
+                ENDDO
+
+                IF ( ic > id )  RETURN
+
+             ENDIF
+
+             ibase = 0
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ib+i) + (a(ia+i)+a(ic+i))
+                   c(jd+j) = b(ib+i) - (b(ia+i)+b(ic+i))
+                   c(jb+j) = (sin60*(a(ia+i)-a(ic+i))) - (0.5_wp*(b(ia+i)+b(ic+i))+b(ib+i))
+                   c(jf+j) = -(sin60*(a(ia+i)-a(ic+i))) - (0.5_wp*(b(ia+i)+b(ic+i))+b(ib+i))
+                   c(jc+j) = sin60*(b(ic+i)-b(ia+i)) + (0.5_wp*(a(ia+i)+a(ic+i))-a(ib+i))
+                   c(je+j) = sin60*(b(ic+i)-b(ia+i)) - (0.5_wp*(a(ia+i)+a(ic+i))-a(ib+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             ssin60 = 2.0_wp * sin60
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = (2.0_wp*(a(ia+i)+a(id+i))) + (2.0_wp*(a(ib+i)+a(ic+i)))
+                   c(jd+j) = (2.0_wp*(a(ia+i)-a(id+i))) - (2.0_wp*(a(ib+i)-a(ic+i)))
+                   c(jb+j) = (2.0_wp*(a(ia+i)-a(id+i))+(a(ib+i)-a(ic+i))) - (ssin60*(b(ib+i)+b(ic+i)))
+                   c(jf+j) = (2.0_wp*(a(ia+i)-a(id+i))+(a(ib+i)-a(ic+i))) + (ssin60*(b(ib+i)+b(ic+i)))
+                   c(jc+j) = (2.0_wp*(a(ia+i)+a(id+i))-(a(ib+i)+a(ic+i))) - (ssin60*(b(ib+i)-b(ic+i)))
+                   c(je+j) = (2.0_wp*(a(ia+i)+a(id+i))-(a(ib+i)+a(ic+i))) + (ssin60*(b(ib+i)-b(ic+i)))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 8
+       CASE ( 6 )
+
+          IF ( la /= m )  THEN
+             ierr = 3
+             RETURN
+          ENDIF
+
+          ia = 1
+          ib = ia + la*inc1
+          ic = ib + 2*la*inc1
+          id = ic + 2*la*inc1
+          ie = id + 2*la*inc1
+          ja = 1
+          jb = ja + jink
+          jc = jb + jink
+          jd = jc + jink
+          je = jd + jink
+          jf = je + jink
+          jg = jf + jink
+          jh = jg + jink
+          ssin45 = SQRT( 2.0_wp )
+
+          DO  l = 1, la
+             i = ibase
+             j = jbase
+             !DIR$ IVDEP
+             !CDIR NODEP
+             !OCL NOVREC
+             DO  ijk = 1, lot
+                c(ja+j) = 2.0_wp*(((a(ia+i)+a(ie+i))+a(ic+i))+(a(ib+i)+a(id+i)))
+                c(je+j) = 2.0_wp*(((a(ia+i)+a(ie+i))+a(ic+i))-(a(ib+i)+a(id+i)))
+                c(jc+j) = 2.0_wp*(((a(ia+i)+a(ie+i))-a(ic+i))-(b(ib+i)-b(id+i)))
+                c(jg+j) = 2.0_wp*(((a(ia+i)+a(ie+i))-a(ic+i))+(b(ib+i)-b(id+i)))
+                c(jb+j) = 2.0_wp*((a(ia+i)-a(ie+i))-b(ic+i)) + ssin45*((a(ib+i)-a(id+i))-(b(ib+i)+b(id+i)))
+                c(jf+j) = 2.0_wp*((a(ia+i)-a(ie+i))-b(ic+i)) - ssin45*((a(ib+i)-a(id+i))-(b(ib+i)+b(id+i)))
+                c(jd+j) = 2.0_wp*((a(ia+i)-a(ie+i))+b(ic+i)) - ssin45*((a(ib+i)-a(id+i))+(b(ib+i)+b(id+i)))
+                c(jh+j) = 2.0_wp*((a(ia+i)-a(ie+i))+b(ic+i)) + ssin45*((a(ib+i)-a(id+i))+(b(ib+i)+b(id+i)))
+                i = i + inc3
+                j = j + inc4
+             ENDDO
+             ibase = ibase + inc1
+             jbase = jbase + inc2
+          ENDDO
+
+    END SELECT
+
+ END SUBROUTINE rpassm
 
 !------------------------------------------------------------------------------!
